#!/usr/bin/python
import dbus
import ClientForm
import ClientCookie

NM_DBUS_SERVICE = "org.freedesktop.NetworkManager"
NM_DBUS_INTERFACE = "org.freedesktop.NetworkManager"
NM_DBUS_OPATH = "/org/freedesktop/NetworkManager"

# This list describe differents networks, it contains :
# - reference to the combo used in the .glade file
# - name of the network
# - an url that should not be accessible when not authenticated
# - part of the url you should be redirected to if not authenticated
# - name of the form field used for login purpose
# - name of the form field used for password purpose
LOGIN_LIST = [
			  [0, "Fon", "http://www.free.fr", "https://login.fon.com", "email", "password"]
			 ]

def has_to_connect(applet):
    # Read params for this type of connection
    for item in LOGIN_LIST:
        if item[0] == applet.type:
            non_authorized_url = item[2]
            connect_location = item[3]
            login_field = item[4]
            password_field = item[5]

    # Try to connect to a non authorized site
    response = ClientCookie.urlopen(non_authorized_url)
    url_response = response.geturl()
	    
    # If response url is our connect_url then we are not connected
    Pos = url_response.find(connect_location)
    if Pos >= 0:
		forms = ClientForm.ParseResponse(response, backwards_compat=False)
		response.close()
		return [forms,login_field,password_field]
    else:
    	response.close()
    	return False
			 
def connect(applet):
	#TODO : error management and return False
	return_list = has_to_connect(applet)
	if return_list == False:
		return True
	else:
		# Parsing the first form of the page
		form = return_list[0][0]
		form[return_list[1]] = applet.login
		form[return_list[2]] = applet.password
		request2 = form.click()
		response2 = ClientCookie.urlopen(request2)
		response2.close()
		return True

def test_dbus():
    bus = dbus.SystemBus()
    nm_obj = bus.get_object(NM_DBUS_SERVICE, NM_DBUS_OPATH)
    nm = dbus.Interface(nm_obj, NM_DBUS_INTERFACE)

    devices = nm.getDevices()
    print devices
    for op in devices:
        dev_obj = bus.get_object(NM_DBUS_SERVICE, op)
        dev = dbus.Interface(dev_obj, NM_DBUS_INTERFACE)
        props = dev.getProperties()
        if props[4] == True:
            print "Device %s is the active device" % op
            connect()

